{
  Copyright 2001 Noah Vawter

  This file is part of Knobs.

  Knobs is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  Knobs is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Knobs; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
}

.module KNOBS;

.global do_knobs;
.global knob1,knob2,knob3,knob4;

.var/dm/ram
        knobcountdown,
        knobnum,
        knob1,knob2,knob3,knob4;

.init knobcountdown:0x1;
.init knobnum:0x0;

{ update knobs }
do_knobs:       
        ax0  = dm(knobcountdown);
        ay0  = 1;
        ar   = ax0-ay0;
        none = pass ar;
        if eq jump yes_knobs;

        dm(knobcountdown)=ar;
        rts;

yes_knobs:
        ax0  = 400;dm(knobcountdown)=ax0;

        ax1 = dm(knobnum);

        ay1 = 0;none=ax1-ay1;if eq jump read_knob1;
        ay1 = 1;none=ax1-ay1;if eq jump read_knob2;
        ay1 = 2;none=ax1-ay1;if eq jump read_knob3;
        ay1 = 3;none=ax1-ay1;if eq jump read_knob4;

        ay1 = 0;   dm(knobnum)=ay1;

read_knob1:
        ax0 = io(0x000);
        dm(knob4)=ax0;
        ay1 = 1;
        jump knob_done;

read_knob2:
        ax0 = io(0x100);
        dm(knob1)=ax0;
        ay1 = 2;
        jump knob_done;

read_knob3:
        ax0 = io(0x200);
        dm(knob2)=ax0;
        ay1 = 3;
        jump knob_done;

read_knob4:
        ax0 = io(0x300);
        dm(knob3)=ax0;
        ay1 = 0;

knob_done:
        dm(knobnum) = ay1;
        rts;

.endmod;

